/* $Id: config2.h,v 1.2 2003/10/28 16:39:47 short Exp $
 * Supplemental include file for config.h of libcaptive
 * Copyright (C) 2003 Jan Kratochvil <project-captive@jankratochvil.net>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; exactly version 2 of June 1991 is required
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#ifndef _CAPTIVE_CONFIG2_H
#define _CAPTIVE_CONFIG2_H 1


/* We need to redefine it here as any '#undef' in config.h gets commented
 * out during 'config.h.in' -> 'config.h' pass.
 */
#if defined(__GNUC__) && (__GNUC__ >= 3)
#include <glib/gmacros.h>	/* for 'G_STRLOC' */
#  undef  G_STRLOC
/* '__func__' does not string-concatenate! */
#  define G_STRLOC	__func__
#endif


/* g_log() and g_logv() acceleration */
#ifdef LIBCAPTIVE
#include <glib/gmessages.h>	/* for g_log() */
#include <glib/gtypes.h>	/* for 'gboolean' */
extern gboolean captive_debug_messages_disabled;
#define g_log(log_domain,log_level,format,args...) ({ \
		GLogLevelFlags _captive_g_log_log_level=(log_level); \
		if ((_captive_g_log_log_level&~(G_LOG_LEVEL_MESSAGE|G_LOG_LEVEL_INFO|G_LOG_LEVEL_DEBUG)) \
				|| !captive_debug_messages_disabled) \
			g_log((log_domain),_captive_g_log_log_level,(format) , ## args); \
		})
#define g_logv(log_domain,log_level,format,args) ({ \
		GLogLevelFlags _captive_g_logv_log_level=(log_level); \
		if ((_captive_g_logv_log_level&~(G_LOG_LEVEL_MESSAGE|G_LOG_LEVEL_INFO|G_LOG_LEVEL_DEBUG)) \
				|| !captive_debug_messages_disabled) \
			g_logv((log_domain),_captive_g_logv_log_level,(format),(args)); \
		})
#endif /* LIBCAPTIVE */


#endif /* _CAPTIVE_CONFIG2_H */
